<?
IPSUtils_Include ("IPSLogger.inc.php", "IPSLibrary::app::core::IPSLogger");
IPSLogger_SetOutEcho(false, c_LogLevel_All);

// Die Konfigurationsdatei von IPSShadowing wird bentigt
IPSUtils_Include ("IPSShadowing_Configuration.inc.php", "IPSLibrary::config::modules::IPSShadowing");
// Die Konfigurationsdatei von IPSLight wird bentigt
IPSUtils_Include ("IPSLight_Configuration.inc.php", "IPSLibrary::config::modules::IPSLight");

IPSUtils_Include ("IPSInstaller.inc.php",               "IPSLibrary::install::IPSInstaller");
IPSUtils_Include ("IPSComponent.class.php",             "IPSLibrary::app::core::IPSComponent");
IPSUtils_Include ("IPSShadowing.inc.php",				"IPSLibrary::app::modules::IPSShadowing");
IPSUtils_Include ("IPSShadowing_Constants.inc.php",     "IPSLibrary::app::modules::IPSShadowing");
IPSUtils_Include ("IPSShadowing_Custom.inc.php",        "IPSLibrary::config::modules::IPSShadowing");
IPSUtils_Include ("IPSShadowing_Logging.inc.php",       "IPSLibrary::app::modules::IPSShadowing");

IPSUtils_Include ("IPSLight.inc.php",					"IPSLibrary::app::modules::IPSLight");

include_once("ENO_Code_Handler_FSB14.ips.php");
include_once("ENO_Code_Handler_FSR14.ips.php");

// Klasse ENO_Code_Handler soll mit den DATA und ODATA Packeten aus der RegVar umgehen
class ENO_Code_Handler{
	// Variablen des Enocean Code Handlers definieren
	public $LData;
	public $LOData;
	public $PType;
	public $MyData;
	public $MyOData;
	public $R_ORG = "00";
	public $UserData;
	public $ReturnID;
	public $Status;
	public $SubTelNum;
	public $Destination_ID;
	public $RSSI;
	public $SecurityLevel;
	public $DeviceID;
	public $DeviceName;
	public $InstanceID;
	public $ReceiveArray;

	public function __construct($LData_in,$LOData_in,$PType_in,$MyData_in,$MyOData_in){
		$this->LData = $LData_in;
		$this->LOData = $LOData_in;
		$this->PType = $PType_in;
		$this->MyData = $MyData_in;
		$this->MyOData = $MyOData_in;
   } // public function __construct($LData_in,$LOData_in,$PType_in,$MyData_in,$MyOData_in)

	public function ENO_Code_Identification(){

		// Es werden nur PType = 1 Datenstze verarbeitet.
		switch ($this->PType)
		{
			case 1:
				IPSLogger_Dbg(__function__, "Length of Data: ".$this->LData."\n");
				IPSLogger_Dbg(__function__, "Length of optional Data: ".$this->LOData."\n");
				IPSLogger_Dbg(__function__, "PType: ".$this->PType."\n");
				IPSLogger_Dbg(__function__, "Data: ".implode(" ",$this->MyData)."\n");
				IPSLogger_Dbg(__function__, "optional Data: ".implode(" ",$this->MyOData)."\n");

				// Data auswerten:
				$this->R_ORG = $this->MyData[0];
				IPSLogger_Dbg(__function__, "R_ORG: ".$this->R_ORG."\n");
				$this->UserData = array_slice($this->MyData,1,$this->LData-6);
				IPSLogger_Dbg(__function__, "UserData: ".implode(" ",$this->UserData)."\n");
				$this->ReturnID = implode(" ",(array_slice($this->MyData,$this->LData-5,4)));
				IPSLogger_Dbg(__function__, "ReturnID: ".$this->ReturnID."\n");
				$this->Status = $this->MyData[$this->LData-1];
				IPSLogger_Dbg(__function__, "Status: ".$this->Status."\n");

				// Optional Data auswerten:
				$this->SubTelNum = $this->MyOData[0];
				IPSLogger_Dbg(__function__, "SubTelNum: ".$this->SubTelNum."\n");
				$this->Destination_ID = implode(" ",(array_slice($this->MyOData,1,4)));
				IPSLogger_Dbg(__function__, "Destination_ID: ".$this->Destination_ID."\n");
				$this->RSSI = -hexdec($this->MyOData[5]);
				IPSLogger_Dbg(__function__, "RSSI: ".$this->RSSI."\n");
				if ($this->MyOData[6] == "00")
				{
					$this->SecurityLevel = "telegram unencrypted";
					IPSLogger_Dbg(__function__, "SecurityLevel: ".$this->SecurityLevel."\n");
				} else
				{
					$this->SecurityLevel = "telegram encrypted";
					IPSLogger_Dbg(__function__, "SecurityLevel: ".$this->SecurityLevel."\n");
				};
			break;

			case 2:
				IPSLogger_Dbg(__function__, "Length of Data: ".$this->LData."\n");
				IPSLogger_Dbg(__function__, "Length of optional Data: ".$this->LOData."\n");
				IPSLogger_Dbg(__function__, "PType: ".$this->PType."\n");
				IPSLogger_Dbg(__function__, "Data: ".implode(" ",$this->MyData)."\n");
				IPSLogger_Dbg(__function__, "optional Data: ".implode(" ",$this->MyOData)."\n");

				// Data auswerten:
				$this->UserData = $this->MyData[0];
				IPSLogger_Dbg(__function__, "UserData: ".$this->UserData."\n");
				$this->ReturnID = implode(" ",(array_slice($this->MyData,$this->LData-4,4)));

				// Optional Data auswerten:
				if ($this->LOData > 0){
					$this->SubTelNum = $this->MyOData[0];
					IPSLogger_Dbg(__function__, "SubTelNum: ".$this->SubTelNum."\n");
				}
			break;
		} // End Switch PType
	} // Ende public function ENO_Code_Identification()
	
	public function ENO_Device_Identification(){
		IPSLogger_Dbg(__function__, "Gestartet\n");
		IPSLogger_Dbg(__function__, "ReturnID: $this->ReturnID \n");
		//Schleife um das Gateway-Signal zu filtern. ID FF F9 68 80
		if ($this->ReturnID === "FF F9 68 80"){	
			IPSLogger_Dbg(__function__, "UserData: $this->UserData[0] \n");
			switch($this->UserData[0])
			{
				case "00":
					IPSLogger_Dbg(__function__, "Das Enocean Gateway funktioniert\n");
				break;
				
				case "01":
					IPSLogger_Err(__function__, "Das Enocean Gateway meldet einen Fehler\n");
				break;
				
				default:
					IPSLogger_Inf(__function__, "Das Enocean Gateway berprfen\n");
				break;
			}
			return;
		} elseif ($this->ReturnID === "00"){
			IPSLogger_Dbg(__function__, "Sendeprotokoll besttigt\n");
			return;
		} else {	

		// Schleife ber alle Instanzen um den Wert zu Updaten - Rolllden
		$ShadowingDevice = get_ShadowingConfiguration();
		$counter = 0;
		foreach ($ShadowingDevice as $devices){
			// InstanceID erzeugen
			$TestInstanceID =explode(",",$devices["Component"])[1];
			IPSLogger_Trc(__function__, "InstanceID: ".$TestInstanceID."\n");
			$counter = $counter+1;

    		// ReturnIDs auslesen und als TargetReturnID definieren
			$ReturnIDvalue = @IPS_GetVariableIDByName("ReturnID", $TestInstanceID*1); //VariablenID von ReturnID;
			if ($ReturnIDvalue >= 1){
				IPSLogger_Trc(__function__, "ReturnIDvalue: ".$ReturnIDvalue."\n");
				$TargetReturnID = GetValueString($ReturnIDvalue);
				IPSLogger_Trc(__function__, "TargetReturnID: ".$TargetReturnID."\n");
				if ($TargetReturnID == $this->ReturnID){
					   // DeviceID schreiben
					   $this->DeviceID = $counter;
					   $this->InstanceID = $TestInstanceID*1;
					   IPSLogger_Dbg(__function__, "DeviceID: ".$this->DeviceID."\n");

						// bergabe Array erzeugen
						$this->ReceiveArray = array ($this->RSSI,$this->UserData,$this->InstanceID,$this->DeviceID);
			   
					   // Funktion ENO_FSB14_get aufrufen
						$this->ENO_FSB14 = new Eltako_FSB14();
						IPSLogger_Dbg(__function__, "Funktion ENO_FSB14_get wird aufgerufen\n");
						$this->ENO_FSB14->ENO_FSB14_get($this->ReceiveArray);
						return; // verlsst die Funktion
				}
			} else {
				IPSLogger_Dbg(__function__, "Fr Device".$counter." wurde keine ReturnID Variable gefunden!\n");
			} // Ende ReturIDvalue >1
 		} // Ende foreach ShadowDevice
 		
 		
 		// Schleife ber alle Instanzen um den Wert zu Updaten - Lichter
		$LightDevice = IPSLight_GetLightConfiguration();
		$counter = 0;
		foreach ($LightDevice as $devices){
         // InstanceID erzeugen
			$TestInstanceID =explode(",",$devices[3])[1];
			IPSLogger_Trc(__function__, "Light InstanceID: ".$TestInstanceID."\n");
			$counter = $counter+1;

    		// ReturnIDs auslesen und als TargetReturnID definieren
			$ReturnIDvalue = @IPS_GetVariableIDByName("ReturnID", $TestInstanceID*1); //VariablenID von ReturnID;
			if ($ReturnIDvalue >= 1){
				IPSLogger_Trc(__function__, "ReturnIDvalue: ".$ReturnIDvalue."\n");
				$TargetReturnID = GetValueString($ReturnIDvalue);
				IPSLogger_Trc(__function__, "TargetReturnID: ".$TargetReturnID."\n");
				if ($TargetReturnID == $this->ReturnID){
					   // DeviceID schreiben
					   $this->DeviceID = $counter;
					   $this->DeviceName = $devices[0];
					   $this->InstanceID = $TestInstanceID*1;
					   IPSLogger_Dbg(__function__, "DeviceID: ".$this->DeviceID."\n");
					   IPSLogger_Dbg(__function__, "DeviceName: ".$this->DeviceName."\n");
					   IPSLogger_Dbg(__function__, "InstanceID: ".$this->InstanceID."\n");

						// bergabe Array erzeugen
						$this->ReceiveArray = array ($this->RSSI,$this->UserData,$this->InstanceID,$this->DeviceName);

					   // Funktion ENO_FSR14_get aufrufen
						$this->ENO_FSR14 = new Eltako_FSR14();
						IPSLogger_Dbg(__function__, "Funktion ENO_FSR14_get wird aufgerufen\n");
						$this->ENO_FSR14->ENO_FSR14_get($this->ReceiveArray);
						return; // verlsst die Funktion
				}
			} else {
				IPSLogger_Dbg(__function__, "Fr Device".$counter." wurde keine ReturnID Variable gefunden!\n");
			} // Ende ReturIDvalue >1
			
		} // Ende foreach LightDevice
 		} // Ende if not BaseID
 		
	} // Ende function ENO_Device_Identification()
	
} // Ende Class

?>
