<?
IPSLogger_SetOutEcho(false, c_LogLevel_All);

class Eltako_FSB14
{
	// Diese Funktion wertet die Informationen fr den FSB14 aus und akutalisiert die Variablen
	function ENO_FSB14_get($ReceiveArray)
	{
		//Daten extrahieren
		$RSSI = $ReceiveArray[0];
		$UserData = $ReceiveArray[1];
		$InstanceID = $ReceiveArray[2];
		$DeviceIDhelp = $ReceiveArray[3];

		// IPSShadowing Device initiieren
		$DeviceID = IPSUtil_ObjectIDByPath("Program.IPSLibrary.data.modules.IPSShadowing.Devices.Device".$DeviceIDhelp);
		$device = new IPSShadowing_Device($DeviceID);

		$DeviceName   = IPS_GetIdent($DeviceID);
		$DeviceConfig = get_ShadowingConfiguration();
	
		//RSSI schreiben
		//$RSSIvalue = IPS_GetVariableIDByName("RSSI", $InstanceID); //VariablenID von RSSI;
		//SetValue($RSSIvalue,$RSSI);

		//UserData verarbeiten
		$LUserData = count($UserData);
		IPSLogger_Dbg(__function__, "LUserData: ".$LUserData."\n");
		switch ($LUserData)
		{
			case 1:
				$MovementCode = $UserData[0];
				IPSLogger_Dbg(__function__, "MovementCode: ".$MovementCode."\n");
				switch ($MovementCode)
				{
					// 0x70 "Endlage oben";
					case "70":
						$Eno_Position = IPS_GetVariableIDByName("Position", $InstanceID); //Position in ENO Instanz schreiben
						SetValue($Eno_Position,0);
						$device->MoveByEvent(0); // Fr IPSShadowing
					break;

					// 0x50 "Endlage unten";
					case "50":
						$Eno_Position = IPS_GetVariableIDByName("Position", $InstanceID); //Position in ENO Instanz schreiben
						SetValue($Eno_Position,100);
		  				$device->MoveByEvent(100); // Fr IPSShadowing
					break;

					// 0x01 "Start auf";
					case "01":
						//Bewegung schreiben - keine Anzeige in IPSShadowing bentigt
						$MovementID = IPS_GetVariableIDByName("Movement", $DeviceID); //VariablenID von Movement;
						SetValue($MovementID,14);
					break;

					// 0x02 "Start ab";
					case "02":
						//Bewegung schreiben - keine Anzeige in IPSShadowing bentigt
						$MovementID = IPS_GetVariableIDByName("Movement", $DeviceID); //VariablenID von Movement;
						SetValue($MovementID,11);
					break;
				} // End switch($MovementCode)
			break;

			case 4:
				$MyFahrzeitMSB 	= $UserData[0];
				$MyFahrzeitLSB 	= $UserData[1];
				$MyDirection 	= $UserData[2];
				$MyStatus 		= $UserData[3];
				$PositionID   	= IPS_GetVariableIDByName("Position", $InstanceID); //VariablenID von Position;
				$OldPosition 	= GetValue($PositionID);
				IPSLogger_Dbg(__function__, "Alte Position: $OldPosition\n");

				// Fahrzeit berechnen - Ich gehe derzeit davon aus, dass die Formel stimmt. Muss noch validiert werden.
				$MyFahrzeit = (hexdec($MyFahrzeitLSB) * 0.1) + (hexdec($MyFahrzeitMSB) * 0.1 * 255);
				
				// Fahrtrichtung bestimmen
				switch ($MyDirection)
				{
					case "01": //aufwrts
						$Direction = "aufwrts";
						$SecTotal     = $DeviceConfig[$DeviceName][c_Property_TimeOpening];
						$NewPosition = $OldPosition - (($MyFahrzeit/$SecTotal)*100);
						IPSLogger_Dbg(__function__, "NewPosition: $NewPosition %\n");
						if ($NewPosition < 0) $NewPosition = 0;
					break;

					case "02": //abwrts
						$Direction = "abwrts";
						$SecTotal     = $DeviceConfig[$DeviceName][c_Property_TimeClosing];
						$NewPosition = $OldPosition + ($MyFahrzeit/$SecTotal*100);
						IPSLogger_Dbg(__function__, "NewPosition: $NewPosition %\n");
						if ($NewPosition > 100) $NewPosition = 100;
					break;
				} // End switch ($MyDirection)
				
				IPSLogger_Dbg(__function__, "SecTotal: $SecTotal Sekunden\n");
				IPSLogger_Inf(__function__, "$DeviceName ist $MyFahrzeit Sekunden $Direction gefahren\n");
				IPSLogger_Inf(__function__, "$DeviceName befindet sich bei $NewPosition %\n");

				// Position schreiben in ENO Instanz und IPSShadowing
				$Eno_Position = IPS_GetVariableIDByName("Position", $InstanceID); //Position in ENO Instanz schreiben
				SetValue($Eno_Position,$NewPosition);
				$device->MoveByEvent($NewPosition);
			break;
		} // Ende switch ($LUserData)
	} // Ende ENO_FSB14_get()

	function ENO_FSB14_send()
	{
	} // Ende ENO_FSB14_send()
}
?>
